#!/usr/bin/php
<?php

include_once("../config/config.php");
include_once("../include/functions.php");

###########################################
# Opening configuration file

$handle = @fopen($config, "r");
if ($handle) {
	while (!feof($handle)) {
        	$buffer = fgets($handle, 4096);
		if (preg_match("/ = /",$buffer)) {
			list($varname, $myvalue) = split (" = ", $buffer, 2);
			$varname = rtrim($varname);
			$$varname = rtrim($myvalue);
		}
	}
	fclose($handle);
}

$verbose = 0;
if (isset($argv[1]) && $argv[1] == "-v") $verbose = 1;

##########################################
# Connecting to database
$link = mysql_connect($hostname, $username, $password)
    or die("DB Connection error : " . mysql_error());

$db_selected = mysql_select_db($dbname, $link);
if (!$db_selected)
	die('Impossible to use the DB : ' . mysql_error());

##########################################
# Set the timestamp of the update procedure, this timestamp is used for selecting repositories, that contains any new packages

$sql = "INSERT INTO settings (name, value) VALUES ('repositories_update_timestamp',CURRENT_TIMESTAMP) ON DUPLICATE KEY UPDATE value=CURRENT_TIMESTAMP";
if (!mysql_query($sql)) {
	die("DB: Unable to set set repositories update timestamp: ".mysql_error($link));
}

###########################################
# Get files from repositories

$sql = " SELECT r.name, r.url, r.is_sec, r.arch_id, r.type, r.id, r.os_group_id, r.file_checksum, a.arch
	FROM repositories r, arch a
	WHERE r.arch_id=a.id AND enabled=1 ORDER BY name";

if (!$res = mysql_query($sql)) {
        die("DB: Unable to get repository:".mysql_error($link));
} 

if ($verbose) print "Processing ...\n";

while ($row = mysql_fetch_row($res)) {

	# Process packages
	if ($verbose) print "$row[0] .";

	$url = $row[1];
	$is_sec = $row[2];
	$arch_id = $row[3];
	$repo_type = $row[4];
	$repo_id = $row[5];
	$os_group_id = $row[6];
	$checksum = $row[7];
	$arch_name = $row[8];

	# Check if the repository changed
	$file_checksum =  md5_file($url);
	if ($checksum == $file_checksum) {
		if ($verbose) print " - no change, skipping\n";
		continue;
	} else {
		$sql = "UPDATE repositories SET file_checksum='$file_checksum' WHERE id=$repo_id";
		if (!mysql_query($sql)) {
	                die ("DB: Unable to update repositories: ".mysql_error($link));
	        }
	}

	# Get file from repository
	$filename = $url;
	if (substr($url, -3, 3) == ".gz") {
		# If file has .gz extension, then ungzip it to temporary file
		if (($gzfile = gzopen($url, 'r')) === false) {
	                # Problem getting file, so skip it
			if ($verbose) print " ERROR - cannot get data from $url\n";
			$sql = "UPDATE repositories SET last_access_ok=0 WHERE id=$repo_id";
		        if (!mysql_query($sql)) {
                		die ("DB: Unable to set last access flag for repository: ".mysql_error($link));
		        }
                        continue;
                }
		if ($gzfile) {
			$filename = tempnam("/tmp","pakiti");
			$file = fopen($filename, "w");
			if ($file) {
				while ($content = gzread($gzfile, 10000)) {
					fwrite($file, $content);
				}
			}
			$tmpfile_exists = 1;
			fclose($file);
			gzclose($gzfile);
		}
	} 
	if ($verbose) print ".";
	$sql = "LOCK TABLES act_version WRITE, pkgs WRITE, repositories WRITE" ;
	if (!mysql_query($sql)) {
		die ("DB: Unable to lock tables: ".mysql_error($link));
	}
	if ($filename) {
		switch ($repo_type) {
			case "dpkg":
				process_dpkg_pkgs($filename, $is_sec, $arch_id, $os_group_id, $repo_id);
				break;
			case "rpm":
				process_rpm_pkgs($filename, $is_sec, $arch_id, $arch_name, $os_group_id, $repo_id);
				break;
		}
	}
	if ($tmpfile_exists == 1) unlink($filename);
	$sql = "UPDATE repositories SET last_access_ok=1, timestamp=CURRENT_TIMESTAMP WHERE id=$repo_id";
	if (!mysql_query($sql)) {
		die("DB: Unable to set last access flag for repository: ".mysql_error($link));
	}
	$sql = "UNLOCK TABLES" ;
	if (!mysql_query($sql)) {
		die("DB: Unable to unlock tables: ".mysql_error($link));
	}
	if ($verbose) print ". OK\n";
}

mysql_close($link);
?>
